"""
Licensed to the Apache Software Foundation (ASF) under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  The ASF licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied.  See the License for the
specific language governing permissions and limitations
under the License.
"""

# -*- coding: utf-8 -*-

UNABLE_TO_CONNECT = -1
NOT_SUPPORTED = "n/s"
NOT_AVAILABLE = "n/a"
ERROR_OCCURRED = -2
UNSUPPORTED_VERSION = -3
EXISTING_CLUSTER = -4

#Cluster object timeout(min)
CLUSTER_TIMEOUT = 15

#Alert timeout(min)
ALERT_HISTORY_TIME = 5

#Errors
LATENCY_NOT_CONFIGURED = "error-not-trackingerror-not-trackingerror-not-trackingerror-not-tracking"
CONFIGURING_LATENCY = "error-run-too-short-or-back-too-smallerror-run-too-short-or-back-too-smallerror-run-too-short-or-back-too-smallerror-run-too-short-or-back-too-small"

ERROR_DESCRIPTION = {1: "Unknown Server Error",
     2: "NOT FOUND",
     3: "GENERATION",
     4: "PARAMETER",
     5: "RECORD EXISTS",
     6: "BIN EXISTS",
     7: "CLUSTER KEY MISMATCH",
     8: "PARTITION OUT OF SPACE",
     9: "TIMEOUT",
     10: "NOXDR",
     11: "UNAVAILABLE",
     12: "INCOMPATIBLE TYPE",
     13: "RECORD TOO BIG",
     14: "KEY BUSY",
     15: "SCAN ABORT",
     16: "UNSUPPORTED FEATURE",
     17: "BIN NOT FOUND",
     18: "DEVICE OVERLOAD",
     19: "KEY MISMATCH",
     20: "NAMESPACE NOT FOUND",
     21: "BIN NAME NOT FOUND",
     22: "FORBIDDEN",
     50: "Last 'proto' in a Chunked Sequence",
     51: "Security Not Supported",
     52: "Security Not Enabled",
     53: "Security Scheme Not Supported",
     54: "Unrecognized Command ID",
     55: "Unrecognized Field ID",
     56: "Illegal State (e.g. valid but unexpected command)",
     60: "No User or Unrecognized User",
     61: "User Already Exists",
     62: "No Password or Bad Password",
     65: "No Credential or Bad Credential",
     70: "No Role(s) or Unrecognized Role(s)",
     71: "Role Already Exists",
     72: "No Privilege(s) or Unrecognized Privilege(s)",
     80: "Not Authenticated",
     81: "Role/Privilege Violation"}

#Secret App Key
SECRET_KEY = "a_random_secret_key_$%#!@"

#Alert retry times
NODE_DOWN_RETRY_TIME = 3
NODE_VISIBILITY_RETRY_TIME = 10
CLUSTER_SIZE_MISMATCH_RETRY_TIME = 5
REPL_FACTOR_MISMATCH_RETRY_TIME = 10

#AMC path
AMC_PATH = "/opt/amc/server/"

#Ansible Hosts File Path
ANSIBLE_HOSTS = "/etc/amc/config/ansible_hosts"
ANSIBLE_TIMEOUT = 120   # sec
ANSIBLE_TIMEOUT_ERROR = "Request timed out, Please check if a given user '%s' has sudo privileges or not."

# Local Command Execution Timeout period
LOCAL_COMMAND_TIMEOUT = 120
LOCAL_COMMAND_TIMEOUT_ERROR = "Request timed out. Please check if " + \
    "given user %s has sudo privileges"

#THROUGHPUT HISTORY LIMIT (30 min)
TPS_HISTORY_LIMIT = 1800

#AMC config file path
AMC_CONFIG_PATH = '/etc/amc/config/amc.cfg'

#AMC db path
AMC_DB_PATH = "/etc/amc/amc.db"

#Latency update interval
LATENCY_UPDATE_INTERVAL = 10  # sec

# Machine username/password caching timeout
MACHINE_CREDENTIALS_TIMEOUT = 14  # days

#LATENCY HISTORY LIMIT (30 min)
# for 5 min: change value to 30
LATENCY_HISTORY_LIMIT = 180

# Multi Cluster Update Interval in secs
MULTICLUSTER_UPDATE_INTERVAL = 5
# MultiCluster Update Timeout in minutes
MULTICLUSTER_UPDATE_TIMEOUT = 5

# BACKUP RESULT HISTORY MAINTENANCE TIME (20 sec)
BACKUP_AND_RESTORE_RESULT_HISTORY_TIME = 20

# Estimated max no. of connections per aerospike node from amc
MAX_CONNECTIONS_PER_NODE = 10
SOCKET_QUEUE_SIZE = 10
XDR_SOCKET_QUEUE_SIZE = 5

# Enterprise flag file path
ENTERPRISE_FLAG_FILE = "/opt/amc/enterprise_flag"

# Security Errors
UNRECOGNISED_USER = 60
USER_ALREADY_EXISTS = 61
BAD_PASSWORD = 62
BAD_CREDENTIAL = 65
UNRECOGNISED_ROLE = 70
NOT_AUTHENTICATED = 80
PRIVILEGE_VIOLATION = 81
SECURITY_NOT_ENABLED = 52

# Allowed roles
ALLOWED_ROLES = ['sys-admin']
ROLES = {'user-admin': 0,
         'read': 1,
         'read-write': 2,
         'sys-admin': 3,
         'read-write-udf': 2
        }
PERMISSION_CODES = {'user-admin': 0,
         'sys-admin': 1,
         'read': 10,
         'read-write': 11,
         'read-write-udf': 12
        }

